'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _cliEngineCommand = require('cli-engine-command');

var _cliEngineCommand2 = _interopRequireDefault(_cliEngineCommand);

var _util = require('../../util');

var _util2 = _interopRequireDefault(_util);

var _plugins = require('../../plugins');

var _plugins2 = _interopRequireDefault(_plugins);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

class _class extends _cliEngineCommand2.default {

  async run() {
    let plugins = new _plugins2.default(this.config);
    plugins = plugins.list();
    plugins = plugins.filter(p => p.type !== 'builtin');
    plugins.sort(_util2.default.compare('name'));
    if (!this.flags.core) plugins = plugins.filter(p => p.type !== 'core');
    if (!plugins.length) this.warn('no plugins installed');
    for (let plugin of plugins) {
      let output = `${plugin.name} ${plugin.version}`;
      if (plugin.type !== 'user') output += ` (${plugin.type})`;
      this.log(output);
    }
  }
}
exports.default = _class;
_class.topic = 'plugins';
_class.flags = [{ name: 'core', description: 'show core plugins' }];