'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _cliEngineCommand = require('cli-engine-command');

var _cliEngineCommand2 = _interopRequireDefault(_cliEngineCommand);

var _plugins = require('../../plugins');

var _plugins2 = _interopRequireDefault(_plugins);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

class PluginsInstall extends _cliEngineCommand2.default {

  async run() {
    const plugins = new _plugins2.default(this.config);
    await plugins.install(this.args.plugin);
  }
}
exports.default = PluginsInstall;
PluginsInstall.topic = 'plugins';
PluginsInstall.command = 'install';
PluginsInstall.description = 'installs a plugin into the CLI';
PluginsInstall.help = `
  Example:
    $ heroku plugins:install heroku-production-status
  `;
PluginsInstall.args = [{ name: 'plugin' }];