'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _cliEngineCommand = require('cli-engine-command');

var _cliEngineCommand2 = _interopRequireDefault(_cliEngineCommand);

var _plugins = require('../../plugins');

var _plugins2 = _interopRequireDefault(_plugins);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

class PluginsUpdate extends _cliEngineCommand2.default {

  async run() {
    this.action.start(`${this.config.name}: Updating plugins`);
    let plugins = new _plugins2.default(this.config);
    for (let plugin of plugins.linkedPlugins.list()) {
      this.warn(`Not updating linked plugin ${plugin.name}. Update manually with git.`);
    }
    for (let plugin of plugins.userPlugins) {
      this.action.start(`${this.config.name}: Updating plugin ${plugin.name}`);
      let version = await plugins.needsUpdate(plugin.name);
      if (!version) continue;
      this.action.start(`${this.config.name}: Updating plugin ${plugin.name} to ${version}`);
      await plugins.update(plugin.name, version);
      this.action.stop();
    }
    this.action.start(`${this.config.name}: Updating plugins`);
  }
}
exports.default = PluginsUpdate;
PluginsUpdate.topic = 'plugins';
PluginsUpdate.command = 'update';