'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _cliEngineCommand = require('cli-engine-command');

var _cliEngineCommand2 = _interopRequireDefault(_cliEngineCommand);

var _updater = require('../updater');

var _updater2 = _interopRequireDefault(_updater);

var _update = require('./plugins/update');

var _update2 = _interopRequireDefault(_update);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

class Update extends _cliEngineCommand2.default {

  async run() {
    let updater = new _updater2.default(this.config);
    if (this.config.updateDisabled) this.warn(this.config.updateDisabled);else {
      this.action.start(`${this.config.name}: Updating CLI`);
      let channel = this.args.channel || this.config.channel;
      let manifest = await updater.fetchManifest(channel);
      if (this.config.version === manifest.version && channel === this.config.channel) {
        this.action.stop(`already on latest version: ${this.config.version}`);
      } else {
        this.action.start(`${this.config.name}: Updating CLI to ${this.color.green(manifest.version)}${channel === 'stable' ? '' : ' (' + this.color.yellow(channel) + ')'}`);
        await updater.update(manifest);
        this.action.stop();
      }
    }
    await _update2.default.run([], { config: this.config });
  }
}
exports.default = Update;
Update.topic = 'update';
Update.args = [{ name: 'channel', optional: true }];