'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _cliEngineCommand = require('cli-engine-command');

var _cliEngineCommand2 = _interopRequireDefault(_cliEngineCommand);

var _plugins = require('../plugins');

var _plugins2 = _interopRequireDefault(_plugins);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

class _class extends _cliEngineCommand2.default {

  findPlugin(cmd) {
    const plugins = new _plugins2.default(this.config);
    for (let plugin of plugins.list()) {
      if (plugin.findCommand(this.args['command'])) {
        return plugin;
      }
    }
  }

  async run() {
    const plugin = this.findPlugin(this.args['command']);
    if (!plugin) throw new Error('not found');
    switch (plugin.type) {
      case 'builtin':
        this.log('builtin command');
        break;
      case 'link':
      case 'core':
      case 'user':
        this.log(`Command from ${plugin.type} plugin ${plugin.name}`);
        break;
      default:
        throw new Error('not found');
    }
  }
}
exports.default = _class;
_class.topic = 'which';
_class.args = [{ name: 'command' }];